#define _CRT_SECURE_NO_WARNINGS

#include <stdio.h>
#include <Windows.h>

HANDLE createPortHandle(const char* port, int baudRate)
{
	HANDLE portHandle = CreateFile(port, GENERIC_READ | GENERIC_WRITE, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
	if (portHandle == INVALID_HANDLE_VALUE)
	{
		printf("Cannot open port! %ld\n", GetLastError());
		return portHandle;
	}

	DCB params = { 0 };
	params.DCBlength = sizeof(params);

	GetCommState(portHandle, &params);
	params.BaudRate = baudRate;
	params.ByteSize = 8;
	params.StopBits = 0;
	params.Parity = 0;
	SetCommState(portHandle, &params);

	COMMTIMEOUTS timeouts = { 0 };
	timeouts.ReadIntervalTimeout = 10;
	timeouts.ReadTotalTimeoutConstant = 1;
	timeouts.ReadTotalTimeoutMultiplier = 1;
	timeouts.WriteTotalTimeoutConstant = 50;
	timeouts.WriteTotalTimeoutMultiplier = 50;
	SetCommTimeouts(portHandle, &timeouts);

	return portHandle;
}

static bool terminate = false;

unsigned long _stdcall readFunction(void* params)
{
	HANDLE portHandle = *(HANDLE*)params; 

	char message[256];
	unsigned long bytesRead;

	while (!terminate)
	{
		DWORD state;
		WaitCommEvent(portHandle, &state, NULL);
		if (state & EV_CTS)
		{
			memset(message, 0, 256);
			ReadFile(portHandle, message, 256, &bytesRead, 0);
			if (bytesRead > 0)
			{
				printf("Received message: %s\n", message);
			}
		}
	}

	return 0;
}

int main()
{
	char portName[100];
	printf("Enter port: ");
	scanf("%s", portName);

	HANDLE portHandle = createPortHandle(portName, 115200);
	if (portHandle == INVALID_HANDLE_VALUE)
	{
		return -1;
	}

	unsigned long threadId;
	HANDLE readThread = CreateThread(NULL, 0, readFunction, &portHandle, 0, &threadId);
	
	char message[256];
	do
	{
		fgets(message, 256, stdin);
		message[strlen(message) - 1] = '\0';

		if (strlen(message) > 0)
		{
			unsigned long bytesWritten;
			EscapeCommFunction(portHandle, SETRTS);
			WriteFile(portHandle, message, strlen(message) + 1, &bytesWritten, 0);
			EscapeCommFunction(portHandle, CLRRTS);
			printf("Number of bytes sent: %ld\n", bytesWritten);
		}
	} while (strcmp(message, "x") != 0);

	terminate = true;
	WaitForSingleObject(readThread, INFINITE);
	CloseHandle(readThread);

	CloseHandle(portHandle);

	return 0;
}
